--lua sample

--specify lua odbc module(lua_odbc.dll), and lua init function(luaopen_luasql_odbc)
lib_path = "lua_odbc.dll"
mydll = assert(loadlib(lib_path, "luaopen_luasql_odbc"))

--load lua_odbc.dll
mydll()
print("load lua_odbc!")

--connect to db
env = assert(luasql.odbc())
con = assert(env:connect("DBSAMPLE5", "sysadm", ""))
print("Connect to database DBSample5")

--create table and insert values
con:execute("DROP TABLE lua_employee;")
con:execute("CREATE TABLE lua_employee(emp_id INT, emp_name CHAR(20), emp_salary INT)")
print("Create new table , table name is 'lua_employee'")

--insert data into table: lua_employee
emp_list = 
{
	{id = 1, name = "Rose", salary = 1000},
	{id = 2, name = "Jacky", salary = 1500},
	{id = 3, name = "Veronica", salary = 2000},
}

for i, j in pairs(emp_list) do
	assert(con:execute(string.format( 
	[[INSERT INTO lua_employee VALUES(%s, '%s', %s)]], j.id, j.name, j.salary) ))
end
print("Insert data from emp_list into lua_employee")

--create cursor ,get data from table and print it
cur = assert(con:execute("SELECT * FROM lua_employee"))
row = cur:fetch({}, "a")

while row do
	table.foreach(row, print)
	row = cur:fetch(row, "a")
end
cur:close()

--update table
assert(con:execute( 
	"UPDATE lua_employee SET emp_salary = emp_salary*1.20 WHERE emp_name = 'Veronica'"))
print("Update lua_employee and give a salary raise of %20 to employee named 'Veronica'!")

--delete all data
assert(con:execute("DELETE FROM lua_employee WHERE emp_name = 'Rose'"))
print("Delete the employee who named 'Rose'!")

cur = assert(con:execute("SELECT * FROM lua_employee"))
row = cur:fetch({}, "a")

while row do
	table.foreach(row, print)
	row = cur:fetch(row, "a")
end

assert(con:execute("DROP TABLE lua_employee"))

--close connection
cur:close()
con:close()
env:close()
